#!./haserl
Content-Type: text/html

<?
./header.sh

#####get current date#####
cday=$(date +"%d")
cmonth=$(date +"%m")
cyear=$(date +"%y")

#####read/initialize parameters#####
details="$(echo "$QUERY_STRING" | cut -d '&' -f1 | cut -d '=' -f2)"
[ "$details" = "" ] && details="n"
mode="$(echo "$QUERY_STRING" | cut -d '&' -f2 | cut -d '=' -f2)"
[ "$mode" = "" ] && mode="m"
year="$(echo "$QUERY_STRING" | cut -d '&' -f3 | cut -d '=' -f2)"
[ "$year" = "" ] && year="$cyear"
month="$(echo "$QUERY_STRING" | cut -d '&' -f4 | cut -d '=' -f2)"
[ "$month" = "" ] && month="$cmonth"
day="$(echo "$QUERY_STRING" | cut -d '&' -f5 | cut -d '=' -f2)"
[ "$day" = "" ] && day="$cday"

#####get configuration data#####
if [ -f "./data/config" ]; then
  interf="$(cat "./data/config"|grep "wrt_tinter"|cut -d '=' -f2)"
  unitdv="$(cat "./data/config"|grep "wrt_unitdv"|cut -d '=' -f2)"
fi
if [ "$interf" = "" ]; then
  interf="vlan1"
fi
if [ "$unitdv" = "" ]; then
  unitdv="1048576"
fi

#####calculate previous month/year#####
if [ "$month" != "xx" ] && [ "$year" != "xx" ]; then
  pmonth="$(expr $month - 1)"
  nmonth="$(expr $month + 1)"
  pyear="$year"
  nyear="$year"

  [ "$pmonth" -lt "1" ] && pmonth="12" && pyear="$(expr $year - 1)"
  [ "$pyear" -lt "0" ] && pyear="99"
  [ "$nmonth" -gt "12" ] && nmonth="01" && nyear="$(expr $year + 1)"
  [ "$nyear" -gt "99" ] && nyear="00"
  [ "$(echo "$pmonth" | wc -c)" -lt 3 ] && pmonth="0$pmonth"
  [ "$(echo "$pyear" | wc -c)" -lt 3 ] && pyear="0$pyear"
  [ "$(echo "$nmonth" | wc -c)" -lt 3 ] && nmonth="0$nmonth"
  [ "$(echo "$nyear" | wc -c)" -lt 3 ] && nyear="0$nyear"
fi

#####Print Uptime and Interface#####
echo "<h3>Uptime: $(uptime | cut -d 'p' -f 2 | cut -d 'l' -f1)</h3>"
echo "<h3>Traffic on Interface ${interf}.</h3>"

#####Display current Down/Up speed#####
echo "<FORM>"
echo "<INPUT type=\"button\" class=\"Button\" style=\"width:15em;\" value=\"Current Speed\" onclick=\"window.open('http://$HTTP_HOST/speed.cgi','Speed','width=250,height=150')\">"
echo "</FORM>"

##########Daily traffic data##########
echo "<h3>Day 20$cyear/$cmonth/$cday:</h3>"

if [ -f ./data/$cyear$cmonth$cday ]; then  
  daydw=$(sed -n '1,1p' ./data/$cyear$cmonth$cday)
  dayup=$(sed -n '2,2p' ./data/$cyear$cmonth$cday)
  daydw=$(echo $daydw $unitdv | awk '{print $1 / $2}')
  dayup=$(echo $dayup $unitdv | awk '{print $1 / $2}')
  daytot=$(echo $daydw $dayup | awk '{print $1 + $2}')
else
  daydw="0"
  dayup="0"
  daytot="0"
fi
  
echo "<table id=\"tabtr\">"
echo "<tr><td>Download</td><td>$daydw MB</td></tr>"
echo "<tr><td>Upload</td><td>$dayup MB</td></tr>"
echo "<tr class=\"mark\"><td>Total</td><td>$daytot MB</td></tr>"
echo "</table>"

##########calculate traffic data##########
./bwsum.sh "$details" "$mode" "$year" "$month" "$day"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME?\">"
if [ "$details" = "y" ]; then
  echo "<input type=\"hidden\" name=\"details\" value=\"n\" />"
  echo "<input type=\"hidden\" name=\"mode\" value=\"$mode\" />"
  echo "<input type=\"hidden\" name=\"y\" value=\"$year\" />"
  echo "<input type=\"hidden\" name=\"m\" value=\"$month\" />"
  echo "<input type=\"hidden\" name=\"d\" value=\"$day\" />"
  echo "<input type=\"submit\" class=\"Button\" style=\"width:15em;\" value=\"No details\" class=\"action\"/>"
else
  echo "<input type=\"hidden\" name=\"details\" value=\"y\" />"
  echo "<input type=\"hidden\" name=\"mode\" value=\"$mode\" />"
  echo "<input type=\"hidden\" name=\"y\" value=\"$year\" />"
  echo "<input type=\"hidden\" name=\"m\" value=\"$month\" />"
  echo "<input type=\"hidden\" name=\"d\" value=\"$day\" />"
  echo "<input type=\"submit\" class=\"Button\" style=\"width:15em;\" value=\"Details\" class=\"action\"/>"
fi
echo "</form><hr class=\"ruler\"/><br/>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME?\">"
echo "<input type=\"hidden\" name=\"details\" value=\"$details\" />"
echo "<input type=\"hidden\" name=\"mode\" value=\"$mode\" />"
echo "<input type=\"hidden\" name=\"y\" value=\"$pyear\" />"
echo "<input type=\"hidden\" name=\"m\" value=\"$pmonth\" />"
echo "<input type=\"hidden\" name=\"d\" value=\"$day\" />"
echo "<input type=\"submit\" class=\"Button\" style=\"width:15em;\" value=\"Previous\" class=\"action\"/>"
echo "</form>"

echo "<div>"  
echo "<form style=\"display: inline;\" action=\"http://$HTTP_HOST$SCRIPT_NAME?\">"
echo "<input type=\"hidden\" name=\"details\" value=\"$details\" />"
echo "<input type=\"hidden\" name=\"mode\" value=\"m\" />"
echo "<input type=\"hidden\" name=\"y\" value=\"$cyear\" />"
echo "<input type=\"hidden\" name=\"m\" value=\"$cmonth\" />"
echo "<input type=\"hidden\" name=\"d\" value=\"$cday\" />"
echo "<input type=\"submit\" class=\"Button\" style=\"width:15em;\" value=\"By month\" class=\"action\"/>"
echo "</form>"

echo "<form style=\"display: inline;\" action=\"http://$HTTP_HOST$SCRIPT_NAME?\">"
echo "<input type=\"hidden\" name=\"details\" value=\"$details\" />"
echo "<input type=\"hidden\" name=\"mode\" value=\"b\" />"
echo "<input type=\"hidden\" name=\"y\" value=\"$cyear\" />"
echo "<input type=\"hidden\" name=\"m\" value=\"$cmonth\" />"
echo "<input type=\"hidden\" name=\"d\" value=\"$cday\" />"
echo "<input type=\"submit\" class=\"Button\" style=\"width:15em;\" value=\"By billing period\" class=\"action\"/>"
echo "</form>"
echo "</div><br/>"

echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME?\">"
echo "<input type=\"hidden\" name=\"details\" value=\"$details\" />"
echo "<input type=\"hidden\" name=\"mode\" value=\"$mode\" />"
echo "<input type=\"hidden\" name=\"y\" value=\"$nyear\" />"
echo "<input type=\"hidden\" name=\"m\" value=\"$nmonth\" />"
echo "<input type=\"hidden\" name=\"d\" value=\"$day\" />"
echo "<input type=\"submit\" class=\"Button\" style=\"width:15em;\" value=\"Next\" class=\"action\"/>"
echo "</form><br/>"
  
echo "<form action=\"http://$HTTP_HOST$SCRIPT_NAME?\">"
echo "<input type=\"hidden\" name=\"details\" value=\"$details\" />"
echo "<input type=\"hidden\" name=\"mode\" value=\"y\" />"
echo "<input type=\"hidden\" name=\"y\" value=\"$cyear\" />"
echo "<input type=\"hidden\" name=\"m\" value=\"$cmonth\" />"
echo "<input type=\"hidden\" name=\"d\" value=\"$cday\" />"
echo "<input type=\"submit\" class=\"Button\" style=\"width:15em;\" value=\"Current year\" class=\"action\"/>"
echo "</form>"

./footer.sh
?>
